net.sf.saxon.expr.instruct

## Interface TailCallReturner

- All Known Implementing Classes:
    AnalyzeString, ApplyImports, ApplyTemplates, Assign, AttributeCreator, Block, BreakInstr, CallTemplate, Choose, Comment, ComputedAttribute, ComputedElement, Copy, CopyOf, Doctype, DocumentInstr, EagerLetExpression, ElementCreator, FixedAttribute, FixedElement, ForEach, ForEachGroup, Fork, Instruction, IterateInstr, LetExpression, LocalParamBlock, LocalParamSetter, MergeInstr, Message, MultithreadedApplyTemplates, MultithreadedForEach, NamespaceConstructor, NextIteration, NextMatch, ParentNodeConstructor, ProcessingInstruction, ProcessRegexMatchInstruction, ResultDocument, SimpleNodeConstructor, StreamingApplyTemplates, StreamInstr, TraceExpression, UseAttributeSets, ValueOf, While

      public interface TailCallReturner

  This interface represents an expression that is capable of being processed leaving tail calls for the calling instruction to deal with.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `TailCall` | `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.

- - ### Method Detail

    - #### processLeavingTail

          TailCall processLeavingTail(XPathContext context)
                                      throws XPathException

      ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.
      Parameters:
        `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
      Returns:
        null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.